<template>
  <div>
    <BarChart :chart-data="datacollection" :options="options" :height="300" />
  </div>
</template>

<script>
import BarChart from '@/components/chart/bar.js'
import covertDate from '@/mixins/formateDate'
export default {
  mixins: [covertDate],
  components: {
    BarChart,
  },
  props: {
    amountYear: Number,
  },
  data() {
    return {
      datacollection: null,
      options: null,
      dataSetTotal: [],
      dateLabels: [],
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    getdashboardTime(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountYear
      )
    },
    amountYear(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountYear
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.dateLabels,
        datasets: this.dataSetTotal,
      }
      this.options = {
        labels: true,
        responsive: true,
        maintainAspectRatio: false,
        height: '250',
        scales: {
          yAxes: [
            {
              ticks: {
                beginAtZero: true,
                min: 0,
                stepSize: 500,
                display: true,
              },
              gridLines: {
                display: true,
              },
            },
          ],
          xAxes: [
            {
              ticks: {
                display: true,
                beginAtZero: true,
              },
              gridLines: {
                display: true,
              },
            },
          ],
        },
        plugins: {
          stacked100: { enable: true },

          datalabels: {
            formatter: function (value) {
              if (value == 0) {
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },
        responsive: true,
        maintainAspectRatio: false,
      }
    },
    async getDataAxios(
      timeVal = new Date(),
      expensestable = 0,
      expensestype = 0,
      numYear = 0
    ) {
      if (expensestable) {
        const checkTime = timeVal
        const date = new Date(checkTime)
        const amountYear = numYear - 1

        const firstDay = new Date(date.getFullYear(), 0, 1)
        const lastDay = new Date(date.getFullYear(), 11, 31)

        const dayStart =
          firstDay.getTime() - Math.floor(amountYear / 2) * (365 * 86400000)
        const dayEnd =
          lastDay.getTime() + Math.floor(amountYear / 2) * (365 * 86400000)

        const dataRes = this.totalTypeMulti(expensestable, dayStart, dayEnd)
        const countName = expensestype.map((x) => x.name).length

        const yearNow = new Date(dayEnd).getFullYear()
        const countYear = new Date(dayStart).getFullYear()

        const getArray = this.setArray(
          dataRes,
          countName,
          countYear,
          amountYear
        )
        const getObject = this.setObject(getArray, expensestype, countName)

        this.dataSetTotal = getObject
        this.dateLabels = this.setLabel(yearNow, countYear)
        this.fillData()
      }
    },
    setArray(objData, coutName, countYear, amountYear) {
      const arrayDeserts = new Array(coutName)
      for (var i = 0; i < arrayDeserts.length; i++) {
        arrayDeserts[i] = new Array(2)
      }

      for (var i = 0; i < coutName; i++) {
        for (var j = 0; j < amountYear; j++) {
          let k = countYear + j
          objData.forEach((res) => {
            let d = new Date(res.date)
            if (res.id - 1 == i) {
              if (k == d.getFullYear()) {
                if (arrayDeserts[i][j] > 0) {
                  arrayDeserts[i][j] = arrayDeserts[i][j] + res.price
                } else {
                  arrayDeserts[i][j] = res.price
                }
              }
            }
          })
          if (arrayDeserts[i][j] == null) {
            arrayDeserts[i][j] = ''
          }
        }
      }
      return arrayDeserts
    },
    setObject(arrayData, typeName, countMonth) {
      let datasetts = []
      for (let i = 0; i < countMonth; i++) {
        const dataset = {
          label: typeName[i].name,
          backgroundColor: this.bgColor(i),
          borderColor: ['#FFF'],
          data: arrayData[i],
        }
        datasetts = [...datasetts, dataset]
      }
      return datasetts
    },
    setLabel(yearNow, countYear) {
      let setLabelArray = []
      for (let i = countYear; i <= yearNow; i++) {
        setLabelArray.push(i + 543)
      }
      return setLabelArray
    },
  },
}
</script>
